// DShowEncoderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DShowEncoder.h"
#include "DShowEncoderDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDShowEncoderDlg dialog

CDShowEncoderDlg::CDShowEncoderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDShowEncoderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDShowEncoderDlg)
	m_szSrcFileName = _T("");
	m_szDestFileName = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDShowEncoderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDShowEncoderDlg)
	DDX_Control(pDX, IDC_LIST_FORMAT, m_ctlFormatList);
	DDX_Control(pDX, IDC_LIST_CODEC, m_ctlCodecList);
	DDX_Text(pDX, IDC_EDT_SRC, m_szSrcFileName);
	DDX_Text(pDX, IDC_EDT_DEST, m_szDestFileName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDShowEncoderDlg, CDialog)
	//{{AFX_MSG_MAP(CDShowEncoderDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_BROWSE_SRC, OnBtnBrowseSrc)
	ON_BN_CLICKED(IDC_BTN_BROWSE_DEST, OnBtnBrowseDest)
	ON_BN_CLICKED(IDC_BTN_ENCODE, OnBtnEncode)
	ON_LBN_SELCHANGE(IDC_LIST_CODEC, OnSelchangeListCodec)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDShowEncoderDlg message handlers

BOOL CDShowEncoderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Codec list construction
	int nNumberOfCodec = m_encoder.GetSize();
	for (int i=0; i<nNumberOfCodec; i++) {
		CDSCodec *pCodec = m_encoder.GetAt(i);
		m_ctlCodecList.AddString(pCodec->m_szCodecName);
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDShowEncoderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDShowEncoderDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDShowEncoderDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDShowEncoderDlg::OnBtnBrowseSrc() 
{
	UpdateData(TRUE);

	CFileDialog openDlg(TRUE, NULL, NULL, 0, "WAV File|*.wav|All|*.*||", this);
	if (openDlg.DoModal() == IDOK) {
		m_szSrcFileName = openDlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CDShowEncoderDlg::OnBtnBrowseDest() 
{
	UpdateData(TRUE);
	CFileDialog openDlg(FALSE, "mp3", "newfile", 0, "MP3 File|*.mp3|WAV File|*.wav|All|*.*||", this);
	if (openDlg.DoModal() == IDOK) {
		m_szDestFileName = openDlg.GetPathName();
		UpdateData(FALSE);
	}
	
}

void CDShowEncoderDlg::OnSelchangeListCodec() 
{
	int nCodecNumber = -1;

	CDSCodec* pCodec = m_encoder.GetAt(m_ctlCodecList.GetCurSel());
	m_ctlFormatList.ResetContent();

	int nCount = pCodec->GetSize();
	for (int i=0; i<nCount; i++) {
		CDSCodecFormat* pFormat = pCodec->GetAt(i);
		CString szFormat, szChannel;
		if (pFormat->NumberOfChannels() < 2) {
			szChannel = "Mono";
		} else {
			szChannel = "Stereo";
		}
		szFormat.Format("%s - %d kHz - %d kbps",
						szChannel,
						pFormat->SamplesPerSecond()/1000,
						(pFormat->BytesPerSec()*8)/1000);
		m_ctlFormatList.AddString(szFormat);
	}

}

void CDShowEncoderDlg::OnBtnEncode() 
{
	if (m_ctlCodecList.GetCurSel() < 0) {
		AfxMessageBox("You MUST select a codec...");
		return;
	}
	if (m_ctlFormatList.GetCurSel() < 0) {
		AfxMessageBox("You MUST select a format...");
		return;
	}

	m_encoder.BuildGraph(m_szSrcFileName, m_szDestFileName, m_ctlCodecList.GetCurSel(), m_ctlFormatList.GetCurSel());
}
